<?php
/**
 * Plugin Name: GraphQL Site Logo
 * Description: Adds a siteLogo field to GraphQL RootQuery
 * Version: 1.0.0
 * Author: SofiDev
 */

if ( ! defined( 'ABSPATH' ) ) {
    exit;
}

add_action( 'graphql_register_types', 'register_graphql_site_logo_field' );

function register_graphql_site_logo_field() {
    register_graphql_field( 'RootQuery', 'siteLogo', [
        'type' => 'MediaItem',
        'description' => __( 'The logo set in the customizer', 'your-textdomain' ),
        'resolve' => function() {
            $logo_id = get_theme_mod( 'custom_logo' );

            if ( empty( $logo_id ) ) {
                return null;
            }

            $media_object = get_post( $logo_id );

            if ( ! $media_object || 'attachment' !== $media_object->post_type ) {
                return null;
            }

            return new \WPGraphQL\Model\Post( $media_object );
        }
    ] );
}
